<template>
  <div class="MenuComposeComponent">
    <b-form-group>

      <div
        v-for="choice in $store.state.food.SelectedFood.choices"
        :key="choice._id"
      >
      
        <b-card class="mx-3 mb-2">
          <h6>
            <b>{{ choice.name }}</b> (Obligatoire)
          </h6>
          <b-card-text style="">
            <div v-for="option in choice.options" :key="option._id">
              <b-card class="mx-3 mb-2">
                <h6>
                  <b>{{ option.name }}</b>
                </h6>
                <b-card-text style="">
                  <div class="row">
                    <div class="col">{{ option.price }}€</div>

                    <div class="col-2">
                      <b-form-radio
                        v-model="food.extras[choice.name]"
                        :aria-describedby="choice.name"
                        :name="choice.name"
                        :value="option"
                        required
                      ></b-form-radio>
                    </div>

                  </div>
                </b-card-text>
              </b-card>
            </div>
          </b-card-text>
        </b-card>
      </div>

      <b-card v-if="$store.state.food.SelectedFood.extras.length !== 0" class="mx-3 mb-2">
        <h6>
          <b>Extras</b>
        </h6>
        <b-card-text style="">
          <div
            v-for="extra in $store.state.food.SelectedFood.extras"
            :key="extra._id"
          >
            <b-card class="mx-3 mb-2">
              <h6>
                <b>{{ extra.name }}</b>
              </h6>
              <b-card-text style="">
                <div class="row">
                  <div class="col">{{ extra.price }}€</div>
                  <div class="col">
                    <b-icon
                      @click="minusValue"
                      icon="dash-circle"
                      class=""
                    ></b-icon>
                  </div>
                  <div class="col">
                    <b-form-input v-model="value" disabled></b-form-input>
                  </div>
                  <div class="col">
                    <b-icon
                      @click="plusValue"
                      icon="plus-circle"
                      class=""
                    ></b-icon>
                  </div>
                </div>
              </b-card-text>
            </b-card>
          </div>
        </b-card-text>
      </b-card>
      <div class="mx-auto text-center" > <b-button @click="onSubmit" style="background-color: #1c1c1c; color: #ffbd61">Ajouter au panier</b-button></div>
      
    </b-form-group>
  </div>
</template>

<script lang="ts">
import router from "@/router";
import Vue from "vue";
import { mapActions, mapGetters } from "vuex";

export default Vue.extend({
  name: "ComposeMenuComponent",

  data: () => ({
    selected: "",
    value: 0,
    food: {} as any,
    cart: {
      restaurant: '',
      amount: 0,
      content: [] as Array<any>
    }
  }),

  methods: {
    ...mapActions(["putCart"]),

    onSubmit(){
      let cart_item = {} as any
      cart_item.name = this.food.name;
      cart_item.price = this.food.price;
      cart_item.quantity = this.food.quantity || 1;
      cart_item.extras = this.food.choices || [] as Array<any>;
      Object.keys(this.food.extras).forEach(key => {
        cart_item.extras.push(this.food.extras[key])
      });
      
      this.cart.content.push(cart_item)
      this.calculAmount()
      this.putCart(this.cart)
      router.push('restaurant')
    },

    calculAmount(){
      this.cart.amount = 0;
      this.cart.content.forEach(element => {
        let content_total = element.price;
        if(element.extras){
          console.log(element.extras)
          element.extras.forEach((extra: { price: any; }) => {
            content_total += extra.price
          })
        }
        this.cart.amount += content_total;
      });
    },  

    minusValue() {
      this.value = this.value + 1;
    },
    plusValue() {
      this.value = this.value + 1;
    },
  },

  created() {
    console.log(this.$store.state.food.SelectedFood)

    if(this.$store.state.cart.Cart.content){
      this.cart = this.$store.state.cart.Cart
    }else{
      this.cart.restaurant = this.$store.state.restaurant.SelectedRestaurant._id
      this.cart.amount = 0
      this.cart.content = []
    }

    var food_name = this.$store.state.food.SelectedFood.name
    var food_id = this.$store.state.food.SelectedFood._id
    var food_price = this.$store.state.food.SelectedFood.price

     this.food = {
      _id: food_id,
      name: food_name,
      price: food_price,
      quantity: 1,
      extras: {}
    }
    

    if(!this.$store.state.user.user.id || !this.$store.state.restaurant.SelectedRestaurant._id || !this.$store.state.food.SelectedFood._id){
      router.push('/')
    }
  },
});
</script>

<style scoped></style>
